from __future__ import with_statement
from __future__ import absolute_import
from subprocess import check_output
import re
import sys
from io import open



def submitJob_local(index, commnadExecutable):
    u"""
    This routine is to submit job locally
    One needs to do a little edit based on your own case.

    Step 1: to prepare the job script which is required by your supercomputer
    Step 2: to submit the job with the command like qsub, bsub, llsubmit, .etc.
    Step 3: to get the jobID from the screen message
    :return: job ID
    """

    # Step 1
    myrun_content = u''
    myrun_content += u'#!/bin/sh\n'
    myrun_content += u'#SBATCH -o out\n'
    myrun_content += u'#SBATCH -p cpu\n'
    myrun_content += u'#SBATCH -J USPEX-' + unicode(index) + u'\n'
    myrun_content += u'#SBATCH -t 06:00:00\n'
    myrun_content += u'#SBATCH -N 1\n'
    myrun_content += u'#SBATCH -n 8\n'
    # myrun_content += 'cd ${PBS_O_WORKDIR}\n' check this, must have /cephfs suffix with SBATCH in my case
    myrun_content += commnadExecutable + u'\n'
    with open(u'myrun', u'w') as fp:
        fp.write(myrun_content)

    # Step 2
    # It will output some message on the screen like '2350873.nano.cfn.bnl.local'
    output = unicode(check_output(u'sbatch myrun', shell=True))
    # Step 3
    # Here we parse job ID from the output of previous command
    jobNumber = int(re.findall(ur'\d+', output)[0])
    return jobNumber


if __name__ == u'__main__':
    import argparse
    parser = argparse.ArgumentParser()
    parser.add_argument(u'-i', dest=u'index', type=int)
    parser.add_argument(u'-c', dest=u'commnadExecutable', type=unicode)
    args = parser.parse_args()

    jobNumber = submitJob_local(index=args.index, commnadExecutable=args.commnadExecutable)
    print('<CALLRESULT>')
    print(int(jobNumber))
